<?php

namespace app\admin\controller\student;

use app\admin\model\department\Department;
use app\admin\model\Fault;
use app\admin\model\Report;
use app\common\controller\Backend;
use app\common\model\Config as ConfigModel;
use think\Db;
use think\Env;
use think\exception\PDOException;
use think\exception\ValidateException;

/**
 * sim-练习集合管理
 *
 * @icon fa fa-circle-o
 */
class Practice extends Backend
{

    /**
     * Collection模型对象
     * @var \app\admin\model\teacher\Collection
     */
    protected $model = null;
    protected $exam_model = null;

    protected $whereExtend = null;
    public function _initialize()
    {
        parent::_initialize();
        $this->model = new \app\admin\model\teacher\Collection;
        $this->exam_model = new \app\admin\model\teacher\Exams;
        $this->assignConfig('sim_sim_type', ConfigModel::getSimTypeList());
        $this->assignConfig('sim_question_setting_method', ConfigModel::getSimQuestionList());

        $this->whereExtend['exam_collection_type'] = 1;//练习
        $this->whereExtend['exam_collection_state'] = 2;
    }



    /**
     * 默认生成的控制器所继承的父类中有index/add/edit/del/multi五个基础方法、destroy/restore/recyclebin三个回收站方法
     * 因此在当前控制器中可不用编写增删改查的代码,除非需要自己控制这部分逻辑
     * 需要将application/admin/library/traits/Backend.php中对应的方法复制到当前控制器,然后进行修改
     */

    public function index()
    {
        $isset = $this->model->alias('z')
            ->join('real_exam r','z.exam_collection_id=r.exam_collection_id','left')
            ->where('z.exam_collection_type=1 and z.exam_collection_state=2  and r.endtime=0 and r.user_id='.$this->auth->id)->find();

        if(empty($isset)){
            //提示页面，没有开始的考试
            return $this->view->fetch('tishi');
        }else{
            echo "<script>location.href='/admin/student/practice/into/ids/".$isset['exam_collection_id']."'</script>";
        }
        die();

        //设置过滤方法
        $this->request->filter(['strip_tags', 'trim']);
        if (false === $this->request->isAjax()) {
            return $this->view->fetch();
        }
        //如果发送的来源是 Selectpage，则转发到 Selectpage
        if ($this->request->request('keyField')) {
            return $this->selectpage();
        }
        [$where, $sort, $order, $offset, $limit] = $this->buildparams();
        $list = $this->model
            ->where($where)->where($this->whereExtend)
            ->order($sort, $order)
            ->paginate($limit);
        foreach ($list as $k => $v){
            $exam_isset =  $this->exam_model->where(['user_id'=>$this->auth->id,'exam_collection_id'=>$v['exam_collection_id'],'exam_collection_type'=>1])->find();
            if(isset($exam_isset)){
                $v->is_user_examed = 1;
            }else{
                $v->is_user_examed = 0;
            }
        }
        unset($v);
        $result = ['total' => $list->total(), 'rows' => $list->items()];
        return json($result);
    }

    //进入考试
    public function  into($ids = null)
    {
        $row = $this->model->get($ids);
        if(!$row){
            $this->error('未找到记录');
        }
        $info = $this->exam_model->where(['user_id'=>$this->auth->id,'exam_collection_id'=>$ids])->find();
        if(!empty($info)){
            if(!empty($this->auth->seat_id) && !empty($info['seat_id']) && $this->auth->seat_id!=$info['seat_id']){
                $this->error('已在其他座号有开始的练习，不允许换座号');
            }
            $sim = Db::name('sim')->where('sim_type',$info['sim_type'])->where('seat_id',$this->auth->seat_id)->find();
            if(empty($sim)){
                $this->error('未找到模拟器,不可练习');
            }
            $this->exam_model->where('exam_id',$info['exam_id'])->update(['seat_id'=>$this->auth->seat_id,'sim_id'=>$sim['sim_id']]);
            $info['seat_id'] = $this->auth->seat_id;
            $sim_text = '';
            if(!empty($sim)){
                if($sim['sim_state']==1){
                    $sim_text = '在线';
                }else if($sim['sim_state']==2){
                    $sim_text = '模拟器离线';
                }else if($sim['sim_state']==3){
                    $sim_text = '网关离线';
                }else if($sim['sim_state']==4){
                    $sim_text = '硬件故障异常';
                }else if($sim['sim_state']==5){
                    $sim_text = '手动禁用';
                }
            }
//            模拟器状态 0:可用初始化 1:在线 2:模拟器离线 3:网关离线 4:硬件故障异常 5:手动禁用
            $info['sim_text'] = $sim_text;
        }
        if(!empty($info['starttime']))
        {
            echo "<script>location.href='/admin/student/practice/examing/ids/".$info['exam_id']."'</script>";
            die();
        }
//        if ($this->request->isPost()) {
//            $exam_collection_id = $this->request->post('exam_collection_id');
//            if(empty($info->starttime)){
//                $info->start_time = date('Y-m-d H:i:s');
//                $info->starttime = time();
//            }
//            $info->exam_status = 4;
//            $info->save();
//            $this->success('开始成功','/admin/student/practice/examing/ids/'.$info['exam_id']);
//        }
        $this->assignConfig('exam_id', $info['exam_id']);
        $this->assignConfig('url_type', config('site.url_type'));
        $this->assignConfig('is_fault', Env::get('app.is_fault'));
        $this->view->assign('row', $row);
        return $this->view->fetch();
    }

    public  function  examing($ids = null)
    {
        $row = $this->exam_model->get($ids);
        if(!$row){
            $this->error('未找到记录');
        }
        if ($this->request->isPost()) {
            //先请求接口判断，再进行处理
            if(Env::get('app.is_fault')){
                $url = config('site.url_type').'/sim/real-exam/student/exercise/submit/'.$ids;
                // /dev-api/sim/real-exam/student/exam/submit/{examId}
                $ret = json_decode(send_get($url),true);
                // halt($ret);
                if($ret['code']!=200){
                    $this->error($ret['msg']);
                }
            }

            //计算分数，保存记录
            $params = $this->request->post('row/a');

            $result = false;
            $score = 100;
            $fault_one_score = 25;
            $fault_two_score = 25;
            $fault_three_score = 25;

            //故障现象
            $xianxian_score = 0;
            $xianxian_arr = [];
            $xianxian_content = [];

            //故障部位
            $buwei_score= 0;
            $buwei_arr = [];
            $buwei_content = [];

            //可能原因
            $yuanyin_socre= 0;
            $yuanyin_arr = [];
            $yuanyin_content = [];

            //排除方法
            $fangfa_score= 0;
            $fangfa_arr = [];
            $fangfa_content = [];

            $other_content = [];
            $content = [];

            Db::startTrans();
            try {
                if(!empty($params['other_report'])){
                    //获取数组
                    $other_report = json_decode($params['other_report'],true);
                    if(count($other_report)==1){
                        $other_report[1] = [
                           'xh_id' => 1,
                           'xx_id' => '',
                           'xx_name' => '',
                           'yy_id' => '',
                           'yy_name' => '',
                           'bw_id' => '',
                           'bw_name' => '',
                           'pc_id' => '',
                           'pc_name' => ''
                        ];
                        $other_report[2] = [
                           'xh_id' => 2,
                           'xx_id' => '',
                           'xx_name' => '',
                           'yy_id' => '',
                           'yy_name' => '',
                           'bw_id' => '',
                           'bw_name' => '',
                           'pc_id' => '',
                           'pc_name' => ''
                        ];
                    }else if(count($other_report)==2){
                        $other_report[2] = [
                           'xh_id' => 2,
                           'xx_id' => '',
                           'xx_name' => '',
                           'yy_id' => '',
                           'yy_name' => '',
                           'bw_id' => '',
                           'bw_name' => '',
                           'pc_id' => '',
                           'pc_name' => ''
                        ];
                    }
                    $params['other_report'] = json_encode($other_report);
                }

                //更新考试结束时间
                $row->end_time = date('Y-m-d H:i:s');
                $row->endtime = time();
                $row->exam_status = 5;
                $row->other_report = $params['other_report'];
                $result = $row->save();

                $info = $this->exam_model->where(['exam_id'=>$ids])->find();

                //更新故障是否正确
                $fault_list = Db::name('real_exam_fault')->where(['exam_id'=>$ids,'flag'=>1])->select();
                if(!empty($fault_list)){
                    foreach ($fault_list as $k =>$t){
                        $answer_right = 2;
                        if(!empty($t['sim_fault_question_value']) && !empty($t['sim_fault_answer_value'])){
                            if($t['sim_fault_question_value']!=$t['sim_fault_answer_value'] ){
                                //真实故障id 0002GZBW0001 薄膜开关FPC排线
                                if($t['sim_fault_answer_value']=='00000000' && $t['fault_id'] !='0002GZBW0001'){
                                    $answer_right=2;
                                }
                                $answer_right=1;
                            }
                        }
                        Db::name('real_exam_fault')->where(['ref_id'=>$t['ref_id']])->update(['answer_right'=>$answer_right]);
                    }
                }

                //计算得分，故障是否有扣分  扣分制
                $fault_right_list = Db::name('real_exam_fault')->where(['exam_id'=>$ids,'flag'=>1,'answer_right'=>['>',0]])->select();
                if(!empty($fault_right_list)){
                    if($fault_right_list[0]['answer_right']==1){
                        $fault_one_score = 0;
                    }
                    if($fault_right_list[1]['answer_right']==1){
                        $fault_two_score = 0;
                    }
                    if($fault_right_list[2]['answer_right']==1){
                        $fault_three_score = 0;
                    }
                }
                $fault_right_list = Db::name('real_exam_fault')->where(['exam_id'=>$ids,'flag'=>1])->select();

                //根据故障部位,查找故障现象
                $fault_arr = [$fault_right_list[0]['fault_id'],$fault_right_list[1]['fault_id'],$fault_right_list[2]['fault_id']];
                
                //根据故障部位查找，匹配的排除方法
                $paichu_arr = Report::where(['bw_id'=>['in',$fault_arr],'sim_type'=>$info['sim_type']])->column('pc_id');
                
                // //根据故障部位查找，匹配可能原因
                // $yy_arr = Report::where(['bw_id'=>['in',$fault_arr],'sim_type'=>$info['sim_type']])->column('yy_id');

                //查找故障现象 数组
                $partent_fault_id = Fault::where(['fault_id'=>['in',$fault_arr],'sim_type'=>$info['sim_type']])->column('parent_fault_id');

                //根据故障部位查找，匹配可能原因
                $yy_arr = Fault::where(['parent_fault_id'=>['in',$partent_fault_id],'sim_type'=>$info['sim_type'],'fault_type'=>2])->column('fault_id');

                if(!empty($other_report)){
                    foreach ($other_report as $k => $v) {
                        if(!empty($v['xx_id'])){
                            if(in_array($v['xx_id'],$partent_fault_id)){
                                //故障现象正确
                                
                                $kscore = 0;
                                //故障部位 故障部位错误
                                $buwei_id= '';
                                $paichu_id= '';
                                $yy_id = [];
                                foreach($fault_arr as $kk1 =>$va1){
                                    $fault_find = Fault::where(['fault_id'=>$va1])->find();
                                    if($fault_find['parent_fault_id']==$v['xx_id']){
                                        $buwei_id = $fault_find['fault_id'];
                                        $paichu_id = $fault_find['ref_type4_fault_id'];
                                        $yy_id = Fault::where(['parent_fault_id'=>$fault_find['parent_fault_id'],'sim_type'=>$info['sim_type'],'fault_type'=>2])->column('fault_id');
                                    }
                                }


                                if($v['bw_id']!=$buwei_id){
                                    $buwei_score = 1+$buwei_score;
                                    $kscore = 1+$kscore;
                                    $content[] = [
                                        'gzxz_id'=>$v['xx_id'],
                                        'cx_id'=>$v['bw_id'],
                                        'cx_type'=>'故障部位错写',
                                        'cx_name'=>Fault::where(['fault_id'=>$v['bw_id']])->value('name'),
                                    ];
                                }
                                //故障部位少写
                                //获取当前的故障部位
                                if($buwei_id!=$v['bw_id']){
                                    $buwei_score = 1+$buwei_score;
                                    $kscore = 1+$kscore;
                                    $content[] = [
                                        'gzxz_id'=>$v['xx_id'],
                                        'cx_id'=>$buwei_id,
                                        'cx_type'=>'故障部位少写',
                                        'cx_name'=>Fault::where(['fault_id'=>$buwei_id])->value('name'),
                                    ];
                                }
                            
                                //排除方法  错写
                                if($v['pc_id']!=$paichu_id){
                                    $buwei_score = 1+$buwei_score;
                                    $kscore = 1+$kscore;
                                    $content[] = [
                                        'gzxz_id'=>$v['xx_id'],
                                        'cx_id'=>$v['pc_id'],
                                        'cx_type'=>'排除方法错写',
                                        'cx_name'=>Fault::where(['fault_id'=>$v['pc_id']])->value('name'),
                                    ];
                                }
                                //排放方法  少写
                                if($paichu_id!=$v['pc_id']){
                                    $fangfa_score = 1+$fangfa_score;
                                    $kscore = 1+$kscore;
                                    $content[] = [
                                        'gzxz_id'=>$v['xx_id'],
                                        'cx_id'=>$v['pc_id'],
                                        'cx_type'=>'排除方法少写',
                                        'cx_name'=>Fault::where(['fault_id'=>$buwei_id])->value('name'),
                                    ];
                                }


                                //可能原因 错写
                                foreach (explode(',',$v['yy_id']) as $key => $value) {
                                    if(!in_array($value,$yy_id)){
                                        $yuanyin_socre = 1+$yuanyin_socre;
                                        $kscore = 1+$kscore;
                                        $content[] = [
                                            'gzxz_id'=>$v['xx_id'],
                                            'cx_id'=>$value,
                                            'cx_type'=>'可能原因错写',
                                            'cx_name'=>Fault::where(['fault_id'=>$value])->value('name'),
                                        ];
                                        echo $v['xx_id']."@@@".$value."@@@".$kscore."<br/>";
                                    }
                                }
                                //可能原因 少写
                                foreach ($yy_id as $key1 => $value1) {
                                    $yy_id_arr = explode(',',$v['yy_id']);
                                    if(!in_array($value1,$yy_id_arr)){
                                        $yuanyin_socre = 1+$yuanyin_socre;
                                        $kscore = 1+$kscore;
                                        $content[] = [
                                            'gzxz_id'=>$v['xx_id'],
                                            'cx_id'=>$value1,
                                            'cx_type'=>'可能原因少写',
                                            'cx_name'=>Fault::where(['fault_id'=>$value1])->value('name'),
                                        ];
                                    }
                                }
                                
                                if($kscore>5){
                                   $kscore = '-5';
                                }else if($kscore>0){
                                    $kscore = '-'.$kscore;
                                }else{
                                   $kscore=0; 
                                }
                                $other_content[$k] = [
                                    'gzxz_id'=>$v['xx_id'],
                                    'xh_id' => $k,
                                    'xx_id' => $v['xx_id'],
                                    'xx_name' => $v['xx_name'],
                                    'yy_id' =>$v['yy_id'],
                                    'yy_name' => $v['yy_name'],
                                    'bw_id' => $v['bw_id'],
                                    'bw_name' => $v['bw_name'],
                                    'pc_id' => $v['pc_id'],
                                    'pc_name' => $v['pc_name'],
                                    'cx_type'=>'',
                                    'cx_name'=>$content,
                                    'cx_score'=>$kscore,
                                ];
                            }else{
                                $xianxian_score = 5+$xianxian_score;
                                $other_content[$k] = [
                                    'gzxz_id'=>$v['xx_id'],
                                    'xh_id' => $k,
                                    'xx_id' => $v['xx_id'],
                                    'xx_name' => $v['xx_name'],
                                    'yy_id' =>$v['yy_id'],
                                    'yy_name' => $v['yy_name'],
                                    'bw_id' => $v['bw_id'],
                                    'bw_name' => $v['bw_name'],
                                    'pc_id' => $v['pc_id'],
                                    'pc_name' => $v['pc_name'],
                                    'cx_type'=>'故障现象错写',
                                    'cx_name'=>Fault::where(['fault_id'=>$v['xx_id']])->value('name'),
                                    'cx_score'=>-5,
                                ];
                            }
                        }else{
                            $xianxian_score = 5+$xianxian_score;
                            $other_content[$k] = [
                                'gzxz_id'=>'',
                                'xh_id' => $k,
                                'xx_id' => '',
                                'xx_name' => '',
                                'yy_id' => '',
                                'yy_name' => '',
                                'bw_id' => '',
                                'bw_name' => '',
                                'pc_id' => '',
                                'pc_name' => '',
                                'cx_type'=>'未作答',
                                'cx_name'=>'',
                                'cx_score'=>-5,
                            ];
                        }
                    }
                }else{
                    foreach ($partent_fault_id as $key => $em){
                        $xianxian_score = 5+$xianxian_score;
                        $other_content[] = [
                            'gzxz_id'=>$em,
                            'xh_id' => $key,
                            'xx_id' => '',
                            'xx_name' => '',
                            'yy_id' => '',
                            'yy_name' => '',
                            'bw_id' => '',
                            'bw_name' => '',
                            'pc_id' => '',
                            'pc_name' => '',
                            'cx_type'=>'未作答',
                            'cx_name'=>'',
                            'cx_score'=>-5,
                        ];
                    }
                    unset($em);
                }
                // echo "故障现象得分:".$xianxian_score."<br/>";
                // echo "故障部位得分:".$buwei_score."<br/>";
                // echo "排除方法得分:".$fangfa_score."<br/>";
                // echo "可能原因得分:".$yuanyin_socre."<br/>";
                // die();
                
                $weixiu_score = $xianxian_score+$yuanyin_socre+$buwei_score+$fangfa_score;
                if($weixiu_score>15){
                    $weixiu_score = 15;
                }

                //是否超时
                $overtime_fen = intval((time()-$info['countdown_time']) / 60);
                if($overtime_fen>=10){
                    $overtime_score = 10;
                }else if($overtime_fen>0 && $overtime_fen<10){
                    $overtime_score = $overtime_fen ;
                }else{
                    $overtime_score =0;
                }
                $fault_score = $score-$fault_one_score-$fault_two_score-$fault_three_score-$weixiu_score-$overtime_score;

                //更新考试结果表
                $params['exam_id'] = $ids;
                $params['total'] = $fault_score;//得分;
                $params['fault_one_score'] = $fault_one_score;//得分;
                $params['fault_two_score'] = $fault_two_score;//得分;
                $params['fault_three_score'] = $fault_three_score;//得分;

                $params['xianxian_score'] = $xianxian_score;//得分;
                $params['xianxian_content'] = json_encode($xianxian_content);//错题;

                $params['yuanyin_socre'] = $yuanyin_socre;//得分;
                $params['yuanyin_content'] = json_encode($yuanyin_content);//错题;

                $params['buwei_score'] = $buwei_score;//得分;
                $params['buwei_content'] = json_encode($buwei_content);//错题;

                $params['fangfa_score'] = $fangfa_score;//得分;
                $params['fangfa_content'] = json_encode($fangfa_content);//错题;

                $params['other_jielun'] = json_encode($other_content);//每个答题的得分

                $params['overtime_score'] = $overtime_score;//得分;
                Db::name('real_exam_score')->insert($params);

                $this->exam_model->where(['exam_id'=>$ids])->update(['total_score'=>$fault_score]);

                Db::commit();
            } catch (ValidateException|PDOException|Exception $e) {
                Db::rollback();
                $this->error($e->getMessage());
            }
            if ($result === false) {
                $this->error(__('No rows were inserted'));
            }

            $this->success('交卷成功','/admin/student/practice/analysis/ids/'.$row['exam_id']);
        }


        if(empty($row->starttime)){
            $row->start_time = date('Y-m-d H:i:s');
            $row->starttime = time();
            $row->exam_status = 4;
            $row->save();
        }
        $isloading =1;
        if(empty($row->other_replace)){
            $isloading = 0;
            $row->other_replace = '[{"fault_id":"","request_status":"0"}]';
        }

        $row->other_report_text = !empty($row->other_report) ? json_decode($row->other_report,true) : [];

        //还未开始练习
        $row->limit_duration = $this->model->where(['exam_collection_id'=>$row['exam_collection_id']])->value('limit_duration');
        if(empty($row->starttime)){
            $timer = 60*$row->limit_duration;
        }else{
            $timer = $row->limit_duration*60 - abs(time() - $row->starttime);
        }

        if(empty($row->countdown_time)){
            $duration = 10+$row->limit_duration;
            $this->exam_model->where('exam_id',$ids)->update(['countdown_time'=>strtotime(date('Y-m-d H:i:s', strtotime('+'.$duration.' minute',$row->starttime)))]);
        }

        $departmentdata = [];
        $departmentdata = Fault::where(['replace_part'=>1,'sim_type'=>$row->sim_type])->order('fault_id asc')->select();
        $this->view->assign('departmentdata', $departmentdata);


        //故障现象
        $xianxiang = Fault::where(['fault_type'=>1,'sim_type'=>$row->sim_type])->select();
        $this->view->assign('xianxiang', $xianxiang);


        $row->replace_list =Db::name('real_exam_comp_request')->where(['exam_id'=>$ids])->select();
        $this->assignConfig('ids',$ids);
        $this->assignConfig('timer',$timer);
        $this->assignConfig('isloading',$isloading);
        $this->view->assign('row', $row);
        return $this->view->fetch();
    }


    public function analysis($ids = null)
    {
        if ($this->request->isPost()) {
            $params = $this->request->post('row/a');
            //计算总分到学员考试表
            $this->success('操作成功','/admin/student/practice/index');
        }
        $row = Db::name('real_exam_score')->where('exam_id', $ids)->find();
        if (!$row) {
            $this->error(__('No Results were found'));
        }
        $rows = $this->exam_model->get($ids);
        $row['seat_id'] = $rows->seat_id;
        $row['user_nickname'] = $rows->user_nickname;
        $row['user_username'] = $rows->user_username;
        $row['user_depart_id'] = $rows->user_depart_id;
        $row['user_depart_name'] = Department::where('id',$rows->user_depart_id)->value('name');
        $row['start_time'] = $rows->start_time;
        $row['end_time'] = $rows->end_time;


        $fault_list = Db::name('real_exam_fault')->where(['exam_id'=>$ids,'flag'=>1])->select();
        $row['fault_name_one'] = !empty($fault_list[0]['fault_id']) ? Fault::where('fault_id',$fault_list[0]['fault_id'])->value('name'):'';
        $row['fault_name_two'] = !empty($fault_list[1]['fault_id']) ? Fault::where('fault_id',$fault_list[1]['fault_id'])->value('name'):'';
        $row['fault_name_three'] = !empty($fault_list[2]['fault_id']) ? Fault::where('fault_id',$fault_list[2]['fault_id'])->value('name'):'';

        $row['fault_score'] = 75-$row['fault_one_score']-$row['fault_two_score']-$row['fault_three_score'];

        $report_score = 15-$row['xianxian_score']-$row['yuanyin_socre']-$row['buwei_score']-$row['fangfa_score'];
        $row['report_score'] = $report_score>0?$report_score:0; 

        $other_jielun = !empty($row['other_jielun']) ? json_decode($row['other_jielun'],true):[];
        $this->view->assign('other_jielun', $other_jielun);

        $this->view->assign('row', $row);
        return $this->view->fetch();
    }

}
